function n = nbinrndAppr(r,p)
% Approximations assure less than 1% of total prob mass is displaced
if r>1e3 && p<0.7
	%Normal approx
	m = r*(1-p)/p;
	sd = sqrt(r*(1-p))/p;
	n = max(0, round(m + sd*randn));
elseif p>0.965
	%Poisson approx
	m = r*(1-p)/p;
	n = poissrndAppr(m);
else
	n = nbinrndSingleAppr(r,p);
end