function rnd = nbinrndSingleAppr(r,p)
%nbinrndSingle(r,p) Single random number from the negative binomial distribution.
% No error check

% Generate Poisson random values mixed on gamma random values.
if p > 0.1 
    rnd = poissrndAppr(randg(r)*(1-p)/p);
else
% Generate a sum of geometric random values.  This "discrete" generator
% is slow when R is large.
	rnd = sum(geornd(p,1,r));
end