function r = poissrnd2(lambda)
large1 = 70;%710; %Originally 15. Optimal value probably depends on system and Matlab version.
large2 = 50; %Originally 15. Optimal value probably depends on system and Matlab version.
if numel(lambda) == 1
	if lambda==0
		r = 0;
 	elseif lambda >= large1; 
		alpha = 7/8;
		m = floor(alpha * lambda);
		g = randg(m);
		if g<=lambda
			r = m + quickPoissrnd(lambda-g);
		else
			r = binornd2(m-1, lambda/g);
		end
	else
		r = 0;
		L = exp(lambda);
		P=1/rand;
		if L<inf
			while P<L
				P = P/rand;
				r = r+1;
			end
		else % this almost never happens
			lnP=log(P);
			while lnP<lambda
				lnP = lnP-log(rand);
				r = r+1;
			end
		end
	end
else
	Lcol = lambda(:);
	calc = true(size(Lcol));
	r = zeros(size(lambda));
	calc(Lcol==0) = false;
	large = find(Lcol>=large2);
	if ~isempty(large)
		calc(large) = false;
		r(large) = largePoissrnd(Lcol(large));
	end
	if any(calc) % anything left?
		r(calc) = quickPoissrnd(Lcol(calc));
	end
end

function R = quickPoissrnd(lambda)
R = zeros(size(lambda));
expminusLambda = exp(-lambda);
for i=1:numel(R)
	r = 0;
	emL = expminusLambda(i);
	P=rand;
	if emL>0
		while P>emL
			P = P*rand;
			r = r+1;
		end
	else
		mL = -lambda(i);
		lnP=log(P);
		while lnP>mL
			lnP = lnP+log(rand);
			r = r+1;
		end
	end
	R(i) = r;
end

function R = largePoissrnd(lambda)
% For large lambda, use the method of Ahrens and Dieter as
% described in Knuth, Volume 2, 1998 edition.
R = zeros(size(lambda));
alpha = 7/8;
m = floor(alpha * lambda);

% Generate m waiting times, all at once
x = randg(m);
t = (x <= lambda);

% If we did not overshoot, then the number of additional times
% has a Poisson distribution with a smaller mean.
R(t) = m(t) + poissrnd2(lambda(t)-x(t));

% If we did overshoot, then the times up to m-1 are uniformly
% distributed on the interval to x, so the count of times less
% than lambda has a binomial distribution.
R(~t) = binornd2(m(~t)-1, lambda(~t)./x(~t));

