function x = poissrndAppr(L)
% Uses normal approximation for large values of lambda
large_limit = 160; % A limit of 160 means less than 1% of the probability mass will be misplaced
if numel(L)==1
	if L>large_limit
		x = max(0,round(L + sqrt(L)*randn));
	else
		x = poissrnd2(L);
	end
else
	appr = (L(:)>large_limit); 
	x = zeros(size(L));
	if any(appr)
		La = L(appr);
		x(appr) = max(0,round(La + sqrt(La).*randn(size(La))));
	end
	if any(~appr)
		x(~appr) = poissrnd2(L(~appr));
	end
end